<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
      <!-- <el-form-item label="身体部位标识" prop="bodyAreaType">
        <el-select v-model="queryParams.bodyAreaType" placeholder="请选择身体部位标识" clearable size="small">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item> -->
      <el-form-item label="身体部位名称" prop="bodyAreaName">
        <el-input v-model="queryParams.bodyAreaName" placeholder="请输入身体部位名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <!-- <el-form-item label="问题类型" prop="questionType">
        <el-select v-model="queryParams.questionType" placeholder="请选择问题类型" clearable size="small">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item> -->
      <!-- <el-form-item label="问题类型名称" prop="questionTypeName">
        <el-input v-model="queryParams.questionTypeName" placeholder="请输入问题类型名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item> -->
      <!-- <el-form-item label="创建时间" prop="createTime">
        <el-date-picker v-model="queryParams.createTime" style="width: 240px" value-format="yyyy-MM-dd HH:mm:ss" type="daterange"
                        range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" :default-time="['00:00:00', '23:59:59']" />
      </el-form-item> -->
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['system:dz-type:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['system:dz-type:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="ID" align="center" prop="id" />
      <el-table-column label="身体部位标识" align="center" prop="bodyAreaType" />
      <el-table-column label="身体部位名称" align="center" prop="bodyAreaName" />
      <el-table-column label="问题类型" align="center" prop="questionType" />
      <el-table-column label="问题类型名称" align="center" prop="questionTypeName" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['system:dz-type:update']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['system:dz-type:delete']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <!-- <el-form-item label="身体部位标识" prop="bodyAreaType">
          <el-select v-model="form.bodyAreaType" placeholder="请选择身体部位标识">
            <el-option label="请选择字典生成" value="" />
          </el-select>
        </el-form-item>
        <el-form-item label="身体部位名称" prop="bodyAreaName">
          <el-input v-model="form.bodyAreaName" placeholder="请输入身体部位名称" />
        </el-form-item> -->
        <el-form-item label="部位分类" prop="tid">
          <el-select v-model="bodyAreaName" placeholder="请选择部位分类" @change="selectOne" >
            <!-- <el-option label="请选择字典生成" value="" /> -->
            <el-option
              v-for="item in toplist"
              :key="item.bodyAreaType"
              :label="item.bodyAreaName"
              :value="item.bodyAreaType + '+' + item.bodyAreaName">
              <span style="float: left">{{ item.bodyAreaName }}</span>
              <span style="float: right; color: #8492a6; font-size: 13px">{{ item.bodyAreaType }}</span>
            </el-option>            
          </el-select>
        </el-form-item>

        <el-form-item label="问题类型" prop="questionType">
          <!-- <el-select v-model="form.questionType" placeholder="请选择问题类型">
            <el-option label="请选择字典生成" value="" />            
          </el-select> -->
          <el-select v-model="form.questionType" placeholder="请选择问题类型">
            <el-option v-for="dict in this.getDictDatas(DICT_TYPE.DZ_TYPE_NUM)"
               :key="dict.value" :label="dict.label" :value="dict.value"/>
          </el-select>
        </el-form-item>
        <el-form-item label="问题类型名称" prop="questionTypeName">
          <el-input v-model="form.questionTypeName" placeholder="请输入问题类型名称" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createDzType, updateDzType, deleteDzType, getDzType, getDzTypePage,getDzTypePageGroup, exportDzTypeExcel } from "@/api/system/dzType";

export default {
  name: "DzType",
  components: {
  },
  data() {
    return {
      bodyAreaName: null,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      toptotal: 0,
      // 科室信息列表
      toplist: [],

      // 总条数
      total: 0,
      // 导诊类型列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        bodyAreaType: null,
        bodyAreaName: null,
        questionType: null,
        questionTypeName: null,
        createTime: [],
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
    this.getTopList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 执行查询
      getDzTypePage(this.queryParams).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    getTopList() {
      this.loading = true;
      // 执行查询
      getDzTypePageGroup(this.queryParams).then(response => {
        this.toplist = response.data.list;
        this.toptotal = response.data.total;
        this.loading = false;
      });
    },
    
    selectOne(value) {     //change 触发事件
      this.form.bodyAreaType = value.split("+")[0];
      this.form.bodyAreaName = value.split("+")[1];
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        bodyAreaType: undefined,
        bodyAreaName: undefined,
        questionType: undefined,
        questionTypeName: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加导诊类型";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      this.bodyAreaName = row.bodyAreaName;

      getDzType(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改导诊类型";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateDzType(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createDzType(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除导诊类型编号为"' + id + '"的数据项?').then(function() {
          return deleteDzType(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.$modal.confirm('是否确认导出所有导诊类型数据项?').then(() => {
          this.exportLoading = true;
          return exportDzTypeExcel(params);
        }).then(response => {
          this.$download.excel(response, '导诊类型.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
